=== debian/changelog ===
pmdk (1.8-1ubuntu1) focal; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - libpmemobj c++ bindings are on separate source now
      + d/control: setup transition from libpmemobj-doc to libpmemobj-cpp-doc
        [Can be dropped after 20.04]
    - d/NEWS: added to explain important packaging changes in this update
      [Can be dropped after 20.04]
    - d/README.source: explains some lintian checks and the reason why
      jemalloc is bundled.
    - d/rules: re-enabled TEST34 as it seems to work fine in the Ubuntu
      test runners
  * Dropped:
    - d/control: the valgrind test is failing, remove it from
      build-depends
      [Valgrind tests aren't running due to missing pmemcheck anyway]
  * Added:
    - d/NEWS: note about libvmem and libvmmalloc coming from another
      source package now.

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 06 Feb 2020 11:23:28 -0300

pmdk (1.8-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 31 Jan 2020 18:49:43 +0100

pmdk (1.8~rc1-2) experimental; urgency=medium

  * Pick pre-release fixes.
  * Re-enable out_err_mt tests.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 21 Jan 2020 17:17:23 +0100

pmdk (1.8~rc1-1) experimental; urgency=medium

  * New upstream pre-release.
  * Drop vmem and vmmalloc.
  * Enable ppc64el.
  * Enable KEEP_GOING to list all test failures.
  * Temporarily disable out_err_mt tests.
  * Patch away differences between 1.8-rc1 tarball and tag.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 20 Jan 2020 12:41:24 +0100

pmdk (1.7-1ubuntu1) focal; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - libpmemobj c++ bindings are on separate source now
      + d/control: setup transition from libpmemobj-doc to libpmemobj-cpp-doc
        [Can be dropped after 20.04]
    - d/NEWS: added to explain important packaging changes in this update
      [Can be dropped after 20.04]
    - d/control: the valgrind test is failing, remove it from
      build-depends
    - d/README.source: explains some lintian checks and the reason why
      jemalloc is bundled.
    - d/rules: re-enabled TEST34 as it seems to work fine in the Ubuntu
      test runners
  * Dropped:
    - libpmemobj c++ bindings are on separate source now:
      + d/libpmemobj-doc.install: removed
        [In 1.6.1-2]
      + d/libpmemobj-doc.doc-base: removed
        [In 1.6.1-2]
    - d/t/{daxio-version,rpmemd-version}: adjust the test to cope with
      release candidate versions
      [In 1.7~rc2-1]

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 04 Dec 2019 18:15:12 -0300

pmdk (1.7-1) unstable; urgency=medium

  * Upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 30 Sep 2019 19:20:09 +0200

pmdk (1.7~rc2-1) experimental; urgency=medium

  * New upstream pre-release.
  * Enable python-based tests.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 26 Sep 2019 23:25:26 +0200

pmdk (1.7~rc1-1) experimental; urgency=medium

  * New upstream pre-release.
  * Drop redundant dirs from example paths.
  * Use upstream method to avoid building examples.
  * Multi-Arch settings.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 24 Sep 2019 02:05:38 +0200

pmdk (1.6.1-2) unstable; urgency=medium

  * Verify upstream GPG signatures.
  * Drop unused install files for libpmemobj-doc.
  * Add autopkgtests to compile examples against installed libraries.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 02 Sep 2019 20:41:03 +0200
